/* Copyright Alexander Kromm (mmaulwurff@gmail.com) 2021
 *
 * This file is part of Changenextmap.
 *
 * Changenextmap is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * Changenextmap is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Changenextmap.  If not, see <https://www.gnu.org/licenses/>.
 */

class cnm_EventHandler : EventHandler
{
  override
  void networkProcess(ConsoleEvent event)
  {
    if      (event.name == "changenextmap"   ) changeNextMap();
    else if (event.name == "changenextsecret") changeNextSecret();
  }

// private: ////////////////////////////////////////////////////////////////////////////////////////

  private void changeNextMap()    { changeLevel(level.nextMap,       "no next map!"       ); }
  private void changeNextSecret() { changeLevel(level.nextSecretMap, "no next secret map!"); }

  private
  void changeLevel(string levelName, string errorMessage)
  {
    if (levelName.length() == 0 || levelName.indexOf("enDSeQ") != -1)
    {
      Console.printf("%s", errorMessage);
      return;
    }

    level.changeLevel(levelName, 0, CNM_CHANGELEVEL_FLAGS);
  }

  const CNM_CHANGELEVEL_FLAGS = 0;
}
